﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            //this.ultraGrid1.DisplayLayout.Bands[0].RowLayoutStyle = RowLayoutStyle.GroupLayout;

            // You can remove the Date and Title columns
            DataTable dt = new DataTable("dt");
            //dt.Columns.Add("Title");
            dt.Columns.Add("No");
            dt.Columns.Add("TitleName");
            //dt.Columns.Add("Date");
            dt.Columns.Add("morning");
            dt.Columns.Add("noon");
            dt.Columns.Add("night");

            DataRow dr = dt.NewRow();
            //dr["Title"] = "1";
            dr["No"] = "1";
            dr["TitleName"] = "Title１";
            //dr["Date"] = "4";
            dr["morning"] = "aa";
            dr["noon"] = "bb";
            dr["night"] = "cc";

            dt.Rows.Add(dr);

            dr = dt.NewRow();
            //dr["Title"] = "1";
            dr["No"] = "2";
            dr["TitleName"] = "Title２";
            //dr["Date"] = "4";
            dr["morning"] = "dd";
            dr["noon"] = "ff";
            dr["night"] = "gg";

            dt.Rows.Add(dr);

            DataTable dt2 = new DataTable("dt2");
            //dt.Columns.Add("Title");
            dt2.Columns.Add("No");
            dt2.Columns.Add("TitleName");
            //dt.Columns.Add("Date");
            dt2.Columns.Add("morning");
            dt2.Columns.Add("noon");
            dt2.Columns.Add("night");

            DataRow dr2 = dt2.NewRow();
            //dr["Title"] = "1";
            dr2["No"] = "1";
            dr2["TitleName"] = "Title１";
            //dr["Date"] = "4";
            dr2["morning"] = "aa";
            dr2["noon"] = "bb";
            dr2["night"] = "cc";

            dt2.Rows.Add(dr2);

            dr2 = dt2.NewRow();
            //dr["Title"] = "1";
            dr2["No"] = "2";
            dr2["TitleName"] = "Title２";
            //dr["Date"] = "4";
            dr2["morning"] = "dd";
            dr2["noon"] = "ff";
            dr2["night"] = "gg";

            dt2.Rows.Add(dr2);


            DataSet ds1 = new DataSet();
            ds1.Tables.Add(dt);
            ds1.Tables.Add(dt2);
            ds1.Relations.Add("dt2", dt.Columns["No"], dt2.Columns["No"]);

            ultraGrid1.DataSource = ds1;


            CreateGroupsForBand(0);
            CreateGroupsForBand(1);

            // the column is not allowed moving
            ultraGrid1.DisplayLayout.Override.AllowColMoving = AllowColMoving.NotAllowed;

            // the column is not allowed swapping
            ultraGrid1.DisplayLayout.Override.AllowColSwapping = AllowColSwapping.NotAllowed;

            // cell select type
            ultraGrid1.DisplayLayout.Override.SelectTypeCell = SelectType.Single;

            // column select type
            ultraGrid1.DisplayLayout.Override.SelectTypeCol = SelectType.Extended;

            this.ultraGrid1.DisplayLayout.Override.HeaderClickAction = HeaderClickAction.Select;
            this.ultraGrid1.DisplayLayout.Override.ColumnAutoSizeMode = ColumnAutoSizeMode.AllRowsInBand;

            ultraGrid1.DisplayLayout.Override.HeaderPlacement = HeaderPlacement.FixedOnTop;
            ultraGrid1.DisplayLayout.Bands[1].ColHeadersVisible = false;
            ultraGrid1.DisplayLayout.Bands[1].GroupHeadersVisible = false;

        }

        private void CreateGroupsForBand(int bandIndex)
        {
            // Instead of using RowLayouts you can add groups to the band.
            ColumnsCollection columns = this.ultraGrid1.DisplayLayout.Bands[bandIndex].Columns;

            var titleGroup = this.ultraGrid1.DisplayLayout.Bands[bandIndex].Groups.Add("Title");
            columns["No"].Group = titleGroup;
            columns["TitleName"].Group = titleGroup;

            var dateGroup = this.ultraGrid1.DisplayLayout.Bands[bandIndex].Groups.Add("Date");
            columns["morning"].Group = dateGroup;
            columns["noon"].Group = dateGroup;
            columns["night"].Group = dateGroup;
        }

        private void rbtSchedule1_CheckedChanged(object sender, EventArgs e)
        {
            if (rbtSchedule1.Checked)
            {
                ultraGrid1.DisplayLayout.Bands[0].Columns["morning"].Hidden = false;
            }
            else {

                ultraGrid1.DisplayLayout.Bands[0].Columns["morning"].Hidden = true;
            }
        }

        private void rbtSchedule2_CheckedChanged(object sender, EventArgs e)
        {
            if (rbtSchedule2.Checked)
            {
                ultraGrid1.DisplayLayout.Bands[0].Columns["noon"].Hidden = false;
            }
            else
            {

                ultraGrid1.DisplayLayout.Bands[0].Columns["noon"].Hidden = true;
            }
        }

        private void rbtSchedule3_CheckedChanged(object sender, EventArgs e)
        {
            if (rbtSchedule3.Checked)
            {
                ultraGrid1.DisplayLayout.Bands[0].Columns["night"].Hidden = false;
            }
            else
            {

                ultraGrid1.DisplayLayout.Bands[0].Columns["night"].Hidden = true;
            }
        }

        private void ultraGrid1_AfterGroupPosChanged(object sender, AfterGroupPosChangedEventArgs e)
        {
            if(e.GroupHeaders[0].Band.Index != 0 && 
                (e.PosChanged == PosChanged.Moved || e.PosChanged == PosChanged.Swapped) )
                return;

            foreach (var group in e.GroupHeaders)
            {
                var childGroup = this.ultraGrid1.DisplayLayout.Bands[1].Groups[group.Group.Key];

                childGroup.Header.VisiblePosition = group.Group.Header.VisiblePosition;
            }
        }
    }
}
